From d424a1d1e70b01f31ee852986898b575a24efbb8 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 23/48] implement ModuleComponent(RPM|Module).__eq__()


This allows comparing objects with different identity for equality. This
is needed because these objects usually have quite a short lifetime
because they're frequently recreated from libmodulemd data.

---

diff --git a/modulemd/components/base.py b/modulemd/components/base.py
index 0fd97e0..07ec0cc 100644
--- a/modulemd/components/base.py
+++ b/modulemd/components/base.py
@@ -52,6 +52,14 @@ class ModuleComponentBase(object):
 
     __nonzero__ = __bool__
 
+    def __eq__(self, other):
+        if type(self) != type(other):
+            return False
+
+        return (self.name == other.name
+                and self.rationale == other.rationale
+                and self.buildorder == other.buildorder)
+
     @property
     def name(self):
         """A string property representing the component name."""
diff --git a/modulemd/components/module.py b/modulemd/components/module.py
index 509d2dd..4aaaf58 100644
--- a/modulemd/components/module.py
+++ b/modulemd/components/module.py
@@ -62,6 +62,13 @@ class ModuleComponentModule(ModuleComponentBase):
 
     __nonzero__ = __bool__
 
+    def __eq__(self, other):
+        if not super(ModuleComponentModule, self).__eq__(other):
+            return False
+
+        return (self.repository == other.repository
+                and self.ref == other.ref)
+
     @property
     def repository(self):
         """A string property representing the VCS repository with the modulemd
diff --git a/modulemd/components/rpm.py b/modulemd/components/rpm.py
index b703af2..3e8c0e8 100644
--- a/modulemd/components/rpm.py
+++ b/modulemd/components/rpm.py
@@ -75,6 +75,16 @@ class ModuleComponentRPM(ModuleComponentBase):
 
     __nonzero__ = __bool__
 
+    def __eq__(self, other):
+        if not super(ModuleComponentRPM, self).__eq__(other):
+            return False
+
+        return (self.repository == other.repository
+                and self.ref == other.ref
+                and self.cache == other.cache
+                and self.arches == other.arches
+                and self.multilib == other.multilib)
+
     @property
     def repository(self):
         """A string property representing the VCS repository with the RPM SPEC

